#!/bin/bash

#===========================================================================================
# JVM Configuration
#===========================================================================================
JAVA_OPTS="${JAVA_OPTS} -Djava.security.egd=file:/dev/./urandom"
if [[ "${NACOS_DEBUG}" == "y" ]]; then
  JAVA_OPTS="${JAVA_OPTS} -Xdebug -Xrunjdwp:transport=dt_socket,address=9555,server=y,suspend=n"
  JAVA_OPTS="${JAVA_OPTS} -XX:-OmitStackTraceInFastThrow -XX:+HeapDumpOnOutOfMemoryError -XX:HeapDumpPath=${BASE_DIR}/logs/java_heapdump.hprof"
  JAVA_OPTS="${JAVA_OPTS} -XX:-UseLargePages"
fi

#===========================================================================================
# Setting system properties
#===========================================================================================
# set nacos server ip
ENV_OPTS="${ENV_OPTS} --server.max-http-header-size=524288"
if [[ ! -z "${NACOS_SERVER_IP}" ]]; then
  ENV_OPTS="${ENV_OPTS} --NACOS_SERVER_IP=${NACOS_SERVER_IP}"
fi

if [[ ! -z "${NACOS_NAMESPACE}" ]]; then
  ENV_OPTS="${ENV_OPTS} --NACOS_NAMESPACE=${NACOS_NAMESPACE}"
fi

JAVA_OPTS="${JAVA_OPTS} -jar /app.jar ${ENV_OPTS}"

echo "app is starting, you can docker logs your container"
exec java ${JAVA_OPTS}
