#!/usr/bin/env bash
value=$1
path=$2
forceparam=$3
force=${forceparam:-"true"}
force_update="-U"
if [ $force == false ]
then
  force_update=""
fi
active=${value:-""}
composeFilePath=${path:-""}
app_name="gitlab-sso-oauth2"
image_name="app/${app_name}"
if [ $active == "" ]
then
  app_name=$app_name
else
  app_name="${app_name}-${active}"
fi

docker stop ${app_name}
docker rm ${app_name}
docker rmi ${image_name}
cd ../../../
mvn clean install -Dmaven.test.skip=true $force_update
mvn docker:build
cd target/docker
if [ $active == "" ]
then
  docker-compose up -d
else
  docker-compose -f ${composeFilePath}docker-compose-${active}.yaml up -d
fi
