package com.gitlab.config;

import com.gitlab.util.OAuth2SecurityUtils;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
* @Description OAuth2Config 类（或接口）
* @Author huangshun
* @Date 2024/4/22
*/
@Configuration
@EnableConfigurationProperties(OAuth2Properties.class)
public class OAuth2Config {

    @Bean
    public OAuth2SecurityUtils securityUtils(OAuth2Properties oAuth2Properties){
        return new OAuth2SecurityUtils(oAuth2Properties);
    }
}
