package com.gitlab.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;

/**
* @Description OAuth2Properties 类（或接口）
* @Author huangshun
* @Date 2024/4/22
*/
@Data
@ConfigurationProperties(prefix = "oauth2")
public class OAuth2Properties {

    /**
     * client_id
     */
    private String client_id;
    /**
     * client_secret
     */
    private String client_secret;
    /**
     * 重定向地址
     */
    private String redirect_uri;

    /**
     * 签名KEY
     */
    private String key;
    /**
     * 签名加密公钥
     */
    private String singlePublicKey;
    /**
     * 签名解密私钥
     */
    private String singlePrivateKey;
    /**
     * code超时时间，单位秒
     */
    private Integer codeExpires;
    /**
     * accessToken超时时间，单位秒
     */
    private Integer tokenExpires;
}
