package com.gitlab.exception;


import com.gitlab.enums.BasicErrorCode;

/**
 * @Description BizException 通用业务异常定义
 * @Author huangshun
 * @Date 2023/6/18
 */
public class BizException extends BaseException {
    private static final long serialVersionUID = 1L;

    public BizException(String message) {
        super(message);
        this.setErrorCode(BasicErrorCode.UNKNOWN_ERROR);
    }

    public BizException(ErrorCode errorCode, String message) {
        super(message);
        this.setErrorCode(errorCode);
    }

    public BizException(String message,Throwable e) {
        super(message,e);
        this.setErrorCode(BasicErrorCode.UNKNOWN_ERROR);
    }

}
